#!/usr/local/bin/perl

$BASE_DIR = "users/";

# Read query string and store in $Form
$QueryString = $ENV{QUERY_STRING};

@NameValuePairs = split (/&/, $QueryString);

foreach $NameValue (@NameValuePairs) {
  ($Name, $Value) = split (/=/, $NameValue);
  $Value =~ tr/+/ /;
  $Value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/eg;
  $Form{$Name} = $Value;
}

$user = $ENV{"REMOTE_USER"};
$BASE_DIR = "${BASE_DIR}${user}/";

# HTTP headers
print "Content-type: text/html", "\n\n";
print "<html><body>";

# Get all directories in the category represented by the path $Form{path}
$output = `cd \"$BASE_DIR$Form{path}\"; find * -maxdepth 0 -type d -print`;

# Split the path for the current category
@category_list = split (/\//, $Form{path});

# Read the global config file into Config_global
&parse_config_file ("$BASE_DIR$category_list[0].config", \%Config_global);

# Read the local config file into Config_local
&parse_config_file ("$BASE_DIR$Form{path}\/config", \%Config_local);

dbmopen %ENTRIES, "$BASE_DIR$Form{path}\/entries", 0666;

$len_category_list = -1;
foreach $category (@category_list) {
  $len_category_list++;
}

print "<TABLE WIDTH=\"100%\" BORDER\"0\"><TR><TD ALIGN=\"right\"><A HREF=\"help.htm\">Help</A></TD></TR></TABLE>";

print "<TABLE WIDTH=\"100%\" BORDER=\"0\"><TR><TD>";

$path_so_far = "";

for ($i = 0; $i <= $len_category_list; $i++) {

  $temp = $category_list[$i];
  $temp =~ tr/ /+/;

  if ($i == 0) {
    $path_so_far = "$temp";
  } else {
    print " &gt; ";
    $path_so_far = "$path_so_far\/$temp";
  }

  if ($i == $len_category_list) {
    print "<B>$category_list[$i]</B>";
  } else {
    print "<A HREF=\"display.pl?path=$path_so_far\">$category_list[$i]</A>";
  }

}

print "</TD></TR></TABLE>";

if ( $output ne "" ) {
  $atleast_one_directory_exists = 1;
}

$count = 0;

if ( ( $Config_local{"allow_show_categories"} != 0 ) || ( $Config_global{"admin"} == /$ENV{"REMOTE_USER"}/ ) ) {
    print "<BR><TABLE BGCOLOR=\"#B8B8B8\" WIDTH=\"100%\" BORDER=\"1\"><TR><TD COLSPAN=\"3\">categories :</TD></TR>";

    foreach $directory (split (/\n/, $output)) {
      $count++;

      $temp_directory = "$Form{\"path\"}\/$directory";
      $temp_directory =~ tr/ /+/;

      $atleast_one_directory_exists = 1;
      print "<TD WIDTH=\"33%\" BGCOLOR=\"#C0A784\"><A HREF=\"display.pl?path=$Form{path}\/$directory\">$directory</A></TD>";

      if ($count == 3) {
        print "</TR><TR>";
        $count = 0;
      }
    }

    if ( $count == 1 ) {
        print "<TD COLSPAN=\"2\" BGCOLOR=\"#C0A784\">&nbsp;</TD></TR>";
    }

    if ( $count == 2 ) {
        print "<TD BGCOLOR=\"#C0A784\">&nbsp;</TD></TR>";
    }

    if ( $count == 3 ) {
        print "</TR>";
    }

    if ( ( $Config_local{"allow_create_categories"} != 0 ) || ( $Config_global{"admin"} == /$ENV{"REMOTE_USER"}/ ) ) {

        print "<TR><TD ALIGN=\"right\" COLSPAN=\"3\"><FORM METHOD=\"get\" ACTION=\"add_category.pl\"><INPUT TYPE=\"hidden\" NAME=\"path\" VALUE=\"$Form{path}\"><INPUT TYPE=\"text\" NAME=\"category\"> : <INPUT TYPE=\"submit\" VALUE=\"Add a new category\"</A>";

        print "</TD></TR>";
    }

    print "</TABLE>";
}

if ( ( $Config_local{"allow_add_entry"} != 0 ) || ( $Config_global{"admin"} == /$ENV{"REMOTE_USER"}/ ) ) {

    $temp = $Form{path};
    $temp =~ tr/ /+/;

    print "<BR><CENTER><A HREF=\"add_entry.pl?path=$Form{path}\">Add an entry</A></CENTER><BR>";

}

print "<BR>";


if ( $ENTRIES{"LARGEST_KEY"} eq "" ) {
    if ( $atleast_one_directory_exists == 0 ) {
      if ( ( $Config_local{"allow_delete_category"} != 0 ) || ( $Config_global{"admin"} == /$ENV{"REMOTE_USER"}/ ) ) {

          $temp = $Form{path};
          $temp =~ tr/ /+/;

          print "<CENTER><A HREF=\"del_category.pl?path=$temp\">Delete this category</A></CENTER><BR><BR>";
      }
    }

    print "<BR><BR><CENTER><B>No Entries to display</B></CENTER><BR><BR>";

} else {

    if ( ( $Config_local{"allow_show_entry"} != 0 ) || ( $Config_global{"admin"} == /$ENV{"REMOTE_USER"}/ ) ) {

        for ($i = 0; $i <= $ENTRIES{"LARGEST_KEY"}; $i++) {

            if ($ENTRIES{"${i}_USED"} == 1) {
                $j = 0;
                print "<BR><TABLE BGCOLOR=\"#B8B8B8\" WIDTH=\"100%\" BORDER=\"1\">";
                while ($Config_global{"${j}_key"} ne "") {
                    $key = $Config_global{"${j}_key"};
                    $temp = $ENTRIES{"${i}_$key"};
                    if ($Config_global{"${j}_output"} ne "") {
                        $temp = eval "$Config_global{\"${j}_output\"} $temp";
                    }
#                    $temp =~ s/\n/<BR>/g;
                    print "<TR><TD WIDTH=\"20%\" BGCOLOR=\"#C0A784\"><B>$Config_global{\"${j}_name\"} :</B></TD><TD BGCOLOR=\"#FFFFCC\">$temp</TD></TR>";
                    $j++;
                }
                print "<TR><TD ALIGN=\"right\" COLSPAN=\"2\">";

                $temp = $Form{path};
                $temp =~ tr/ /+/;

                if ( ( $Config_local{"allow_edit_entry"} != 0 ) || ( $Config_global{"admin"} == /$ENV{"REMOTE_USER"}/ ) ){
                    print "<A HREF=\"edit_entry.pl?path=$Form{path}&entry_no=$i\">Edit</A> ";
                }

                if ( ( $Config_local{"allow_delete_entry"} != 0 ) || ( $Config_global{"admin"} == /$ENV{"REMOTE_USER"}/ ) ){
                    print "<A HREF=\"del_entry.pl?path=$Form{path}&entry_no=$i\">Delete</A>";
                }
                print "</TD></TR>";
                print "</TABLE><BR>";
            }
        }
    }
}

#$temp = $ENV{"REMOTE_USER"};
$hhhh = "\&asdf (\$ENV{\"REMOTE_USER\"})";
print "<HR><HR> $hhhh";
$temp = "z";
print " $temp";
$temp = eval "$hhhh";
print "<HR><HR>temp : $temp";

if ( $Config_global{"admin"} == /$ENV{"REMOTE_USER"}/ ) {
print "<HR><HR>";
    foreach $j (keys %ENTRIES) {

        $entry = $ENTRIES{$j};
        print "$j - $entry<BR><BR>";

    }
}

dbmclose %ENTRIES;


sub asdf {

    $y = $_[0];
    return "modified by asdf : $y";

}

#subroutine to parse a config file and store it as a hash.
#Takes 2 arguments - the config file and a reference to the hash

sub parse_config_file {

local ($config_line, $Name, $Value, $Config);

$Config = $_[1];

if (!open (CONFIG, "$_[0]")) {
  print "<B>ERROR</B><BR>Config file not found : $_[0]";
  exit(0);
}

while (<CONFIG>) {
    $config_line=$_;
    chop ($config_line);
    $config_line =~ s/^\s*//;
    $config_line =~ s/\s*$//;
    if ( ($config_line !~ /^#/) && ($config_line ne "") ){
        ($Name, $Value) = split (/=/, $config_line);
        $$Config{$Name} = $Value;
    }
}

close(CONFIG);

}


sub casenum_output {

    $temp = $_[0];
    return "<A HREF=\"http://www-tac.cisco.com/Teams/ks/casekwery/casekwery.php?Case=$temp\">$temp</A>";

}


sub ddtsnum_output {

    $temp = $_[0];
    return "<A HREF=\"http://wwwin-metrics.cisco.com/protected-cgi-bin/ddtsdisp.cgi?id=$temp\">$temp</A>";

}


